import 'package:flutter/material.dart';
import 'package:gpu_video_plugin/gpu_video_plugin.dart';

class Movie extends StatefulWidget {
  const Movie({Key? key}) : super(key: key);

  @override
  State<Movie> createState() => _MovieState();
}

class _MovieState extends State<Movie> {
  String url =
      "https://test-videos.co.uk/vids/bigbuckbunny/mp4/h264/360/Big_Buck_Bunny_360_10s_1MB.mp4";
  List<String> _listFilter = [];
  var duration = 0;
  var currentPosition = 0;
  var isChangeValueFilter = false;
  var valueFilter = 0.0;
  var isPlay = true;

  Future<void> initListFilter() async {
    List<String> listFilter = [];
    listFilter = await Filters.filters;

    setState(() {
      _listFilter = listFilter;
    });
  }

  @override
  void initState() {
    super.initState();
    initListFilter();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Column(
        children: [
          MovieView(url: url, height: 300),
          const Text("MOVIE"),
          Expanded(
              child: ListView.separated(
                  itemBuilder: (_, index) => InkWell(
                      onTap: () async {
                        if (await MovieView.setFilterMovie(
                            _listFilter[index])) {
                          setState(() {
                            isChangeValueFilter = true;
                          });
                        } else {
                          setState(() {
                            isChangeValueFilter = false;
                          });
                        }
                      },
                      child: Text(_listFilter[index])),
                  separatorBuilder: (_, index) => const SizedBox(
                        height: 20,
                      ),
                  itemCount: _listFilter.length)),
          Visibility(
            visible: isChangeValueFilter,
            child: Row(
              children: [
                const Text("Filter"),
                const SizedBox(
                  width: 10,
                ),
                Expanded(
                  child: Slider(
                    max: 100,
                    value: valueFilter,
                    onChanged: (double value) {
                      setState(() {
                        valueFilter = value;
                        MovieView.changeValueFilter(valueFilter.toInt());
                      });
                    },
                  ),
                ),
              ],
            ),
          ),
          Row(
            children: [
              const Text("Time"),
              const SizedBox(
                width: 10,
              ),
              Expanded(
                child: ProcessMovieView(
                  onDuration: (dura) {
                    if (duration != dura) {
                      setState(() {
                        duration = dura;
                      });
                    }
                  },
                  onCurrentPosition: (currentPos) {
                    print("currentPosASSSS:" + currentPos.toString());
                    setState(() {
                      currentPosition = currentPos;
                    });
                  },
                  child: Slider(
                    max: duration.toDouble(),
                    value: currentPosition.toDouble(),
                    onChanged: (double value) {
                      setState(() {
                        currentPosition = value.toInt();
                        MovieView.seekToMovie(value.toInt());
                      });
                    },
                  ),
                ),
              ),
            ],
          ),
          ElevatedButton(
            style: ElevatedButton.styleFrom(
              primary: Colors.blue,
            ),
            onPressed: () {
              setState(() {
                if (isPlay) {
                  MovieView.pause();
                } else {
                  MovieView.play();
                }
                isPlay = !isPlay;
              });
            },
            child: Text(
              isPlay ? "Pause" : "Play",
              style: const TextStyle(
                color: Colors.white,
              ),
            ),
          ),
        ],
      ),
    );
  }
}
