import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:gpu_video_plugin/src/camera_view.dart';

class Camera extends StatelessWidget {
  const Camera({Key? key, required this.width, required this.height})
      : super(key: key);
  final double height;
  final double width;
  static const MethodChannel _channel = MethodChannel('gpu_video_plugin');

  static setFilter(String nameGlFilter) async {
    await _channel.invokeMethod("setFilter", nameGlFilter);
  }

  static Future<void> switchCamera() async {
    // await Future.delayed(const Duration(seconds: 3));
    await _channel.invokeMethod("switchCamera");
    await Future.delayed(const Duration(seconds: 3));
  }

  static flash() async {
    await _channel.invokeMethod("flash");
  }

  static imageCapture() async {
    await _channel.invokeMethod("imageCapture");
  }

  static startRecord() async {
    await _channel.invokeMethod("startRecord");
  }

  static stopRecord() async {
    await _channel.invokeMethod("stopRecord");
  }

  static Future<bool> checkPermissionCamera() async {
    return await _channel.invokeMethod("checkPermission_CAMERA") as bool;
  }

  @override
  Widget build(BuildContext context) {
    return CameraView(width: width, height: height);
  }
}
