import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

class CameraView extends StatefulWidget {
  const CameraView({Key? key, required this.width, required this.height})
      : super(key: key);
  final double height;
  final double width;
  static const MethodChannel _channel = MethodChannel('gpu_video_plugin');

  @override
  _CameraViewState createState() => _CameraViewState();
}

class _CameraViewState extends State<CameraView> {
  int cameraId = 1;
  Future<void> setUp() async {
    final Map<String, dynamic> map = <String, dynamic>{};
    map["cameraHeight"] = widget.height.toInt();
    map["cameraWidth"] = widget.width.toInt();
    cameraId = await CameraView._channel.invokeMethod("setUpCamera", map);
    setState(() {

    });
  }

  @override
  void initState() {

    super.initState();
    setUp();
  }

  @override
  Widget build(BuildContext context) {
    print("flutter:cameraid:$cameraId");
    String viewType = 'gpu_video_plugin_camera_$cameraId';
    Map<String, dynamic> creationParams = <String, dynamic>{};
    return SizedBox(
      width: widget.width,
      height: widget.height,
      child: AndroidView(
        onPlatformViewCreated: (int i){
          setState(() {
            print("AndroidView");
          });
        },
        viewType: viewType,
        layoutDirection: TextDirection.ltr,
        creationParams: creationParams,
        creationParamsCodec: const StandardMessageCodec(),
      ),
    );
  }

  @override
  void dispose() async {
    super.dispose();
    await CameraView._channel.invokeMethod("releaseCamera");
  }
}
