import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:gpu_video_plugin/gpu_video_plugin.dart';

class ImageVideo extends StatelessWidget {
  const ImageVideo(
      {Key? key,
      this.width,
      this.height,
      required this.path,
      })
      : super(key: key);
  final double? height;
  final double? width;
  final String path;

  @override
  Widget build(BuildContext context) {
    // print("build:${videoLoader.imageVideoId}:${path}");_${videoLoader.imageVideoId}
    String viewType = 'image_video_file';
    Map<String, dynamic> creationParams = <String, dynamic>{};
    creationParams['path'] = path;
    return SizedBox(
        height: height,
        width: width,
        child: AndroidView(
          viewType: viewType,
          layoutDirection: TextDirection.ltr,
          creationParams: creationParams,
          creationParamsCodec: const StandardMessageCodec(),
        ));
  }
}
