import 'dart:async';
import 'package:flutter/services.dart';

class VideoLoader {
  static const MethodChannel _channel = MethodChannel('gpu_video_plugin');
  int imageVideoId = 0;
  static void playMovie(String path) async {
    await _channel.invokeMethod("playMovie", path);
  }

  static Future<List<VideoItem>> get videosLoaders async {
    List<VideoItem> list = [];
    final maps = await _channel.invokeMethod("videoLoaders");
    if (maps != null) {
      maps.forEach((element) {
        String path = element["path"];
        int duration = element["duration"];
        int height = element["height"];
        int width = element["width"];
        list.add(VideoItem(
            path: path, duration: duration, width: width, height: height));
      });
    }
    return list;
  }
}

class VideoItem {
  final String path;
  final int duration;
  final int width;
  final int height;

  VideoItem(
      {required this.path,
      required this.duration,
      required this.width,
      required this.height});

  @override
  String toString() {
    return 'VideoItem{path: $path}';
  }
}
